> For the complete documentation index, see [llms.txt](https://docs.win32.run/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.win32.run/developers/spaghetti-code/system-variables.md).

# System Variables

System-wide configurations (file types icons, list of default desktop wallpapers, open with menu, etc.) are set in `src/lib/system.js`

For data that need to be communicated across the system, win32.run uses [Svelte Stores](https://svelte.dev/tutorial/writable-stores). (`src/lib/store.js`). These data structures allow any page to subscribe and listen to their changes.

**Example 1:** any page can request to launch a program with

```javascript
import { queueProgram } from '$lib/store.js'
queueProgram.set(program_details);
```

`src/routes/xp/work_space.svelte` listens to these requests and launches the requested program

```javascript
import { queueProgram } from '$lib/store.js'

queueProgram.subscribe(program_details => {
    if(program_details == null){
        return;
    }
    launch(program_details);
})
```

**Example 2:** the hard drive `hardDrive` (in src/lib/store.js) is also a Svelte Store (actually it's just the inventory of files and folders, the real files' contents are saved in IndexedDB).

Any *native* program can make updates to win32 hard drive with `hardDrive.update(...)` or `hardDrive.set(...).` (Though you should use utilities functions in `$lib/fs.js` like `fs.save_file, fs.del_fs, fs.new_fs_item`)

`src/routes/xp/programs/my_computer.svelte` subscribes to its changes and updates its UI accordingly


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.win32.run/developers/spaghetti-code/system-variables.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
